#!/usr/bin/python
# 
""" Tool for hiding/recovering information from a docx file as XML comments """


import sys,os
from subprocess import Popen,PIPE

def aes_encrypt64(passphrase,fname):
    """ Encrypt to Base64 """
    
    infile = open(fname,"r")
    edata = Popen(['openssl','aes-256-cbc','-k',passphrase,'-e','-base64'],
                  stdin=infile,stdout=PIPE).stdout.read()
    return edata

def aes_decrypt64(passphrase,tempfile):
    """ Decrypt a Base64 representation """
    
    ddata = Popen(['openssl','aes-256-cbc','-k',passphrase,'-d','-base64'],
                  stdin=tempfile,stdout=PIPE).stdout.read()
    return ddata


def get_docx_component(docx_file,component_name):
    return Popen(['unzip','-p',docx_file,'word/document.xml'],stdout=PIPE).stdout.read()    

if(__name__=='__main__'):
    from optparse import OptionParser
    parser = OptionParser()
    parser.add_option("-p","--passphrase",dest="passphrase",help="Specify the passphrase for encryption")
    parser.add_option("-f","--file",dest="file",help="Specify the file to insert or extract")
    parser.add_option("-a","--add",action="store_true",help="Add the FILE to the DOCX file")
    parser.add_option("-x","--extract",action="store_true",help="Extract the FILE from the DOCX file")
    (options,args) = parser.parse_args()

    try:
        docx_file = args[0]
    except IndexError:
        print "You must specify a docx file"
    
    if not docx_file.endswith('.docx'):
        print docx_file,"is not a docx file"
        sys.exit(1)
    
    if not options.passphrase:
        print "Error: You must specify an encryption key"
        sys.exit(0)

    if(options.add):
        if not options.file:
            print "Error: please specify a file to add"
            sys.exit(0)
        encrypted_base64_data = aes_encrypt64(options.passphrase,options.file)
        # Now get the word/document.xml file and insert the encrypted data after the first line
        document_xml = get_docx_componet(docx_file,'word/document.xml')
        document_xml_lines = document_xml.split("\r\n")
        new_document_xml = document_xml_lines[0] + "\r\n" + '<!--' + encrypted_base64_data + '-->' + "\r\n".join(document_xml_lines[1:])
        
        # Now put it back into the file
        os.mkdir("word")
        tempfile = open("word/document.xml","w")
        tempfile.write(new_document_xml)
        tempfile.close()
        Popen(['zip',docx_file,"word/document.xml"]).wait()
        os.unlink("word/document.xml")
        os.rmdir("word")


    if(options.extract):
        if not options.file:
            print "Error: please specify a file to extract into"
            sys.exit(0)

        # Get the data out of the docx file
        encrypted_data = get_docx_component(docx_file,'word/document.xml')
        p1 = encrypted_data.find("<!--")
        p2 = encrypted_data.find("-->")
        if(p1<0):
            print "No encrypted data found in",docx_file
            sys.exit(0)

        import tempfile
        tfile = tempfile.TemporaryFile()
        tfile.write(encrypted_data[p1+4:p2])
        tfile.seek(0)
        print aes_decrypt64(options.passphrase,tfile)

